#include "motor.h"
#include "oled.h"
#include "list_motor.h"

motor_t gm6020;

motor_t gm6020_up;
motor_t gm6020_down;

motor_t m3508_frontleft;
motor_t m3508_frontright;
motor_t m3508_backleft;
motor_t m3508_backright;

const pid_struct_t M3508_pid_speed = { //A VERIFIER
		1, 2, 0.005, 2, 16000, 16000
	};
const pid_struct_t M3508_pid_pos = { //A VERIFIER
		0, 0.1, 0.005, 0, 16000, 16000
	};

const pid_struct_t GM6020_pid_speed = { //A VERIFIER
		1, 40, 10, 0, 30000, 30000
	};
const pid_struct_t GM6020_pid_pos = { //A VERIFIER
		0, 12, 3, 5, 10000, 10000
	};


// void motors_init (motor_t motor, int motor_tx_id, int motor_rx_id, enum motors mot){
// 	switch ()

// 	motor.type = GM6020;
// 	motor.can_info.can_id = 0;
// 	motor.can_info.tx_id = 1;
// 	motor.can_info.rx_id = 0x205; 
// 	motor.pid_pos = GM6020_pid_pos;
// 	motor.pid_speed = GM6020_pid_speed;
// }
//extern motor_t gm6020_down;
//extern motor_t gm6020_up;


void motors_init(motor_t motor,  int motor_rx_id, enum motors mtr){
	switch (mtr){
		case GM6020 :
			motor.type = GM6020 ;
			motor.pid_pos = GM6020_pid_pos;
			motor.pid_speed = GM6020_pid_speed;
			motor.can_info.tx_id = 1;
			break;
		case M3508 :
			motor.type = M3508 ;
			motor.pid_pos = M3508_pid_pos;
			motor.pid_speed = M3508_pid_speed;
			motor.can_info.tx_id = 0;
			break;
		default :
			break;
	}
	motor.can_info.can_id = 0;
	motor.can_info.rx_id = motor_rx_id ;
}

void motors_all_init(void){
	motors_init(gm6020_down,  0x206, GM6020);
	motors_init(gm6020_up,  0x205, GM6020);
	motors_init(m3508_frontleft,  0x204, M3508);
	motors_init(m3508_frontright,  0x203, M3508);
	motors_init(m3508_backleft,  0x202, M3508);
	motors_init(m3508_backright,  0x201, M3508);
}

