
#include "oled.h"
#include "bsp_oled.h"



oled_button_val_t oled_button_val(void){
	int val = oled_button_get_volt();
	
	if (abs(BUTTON_DOWN - val) <= BUTTON_RANGE)
		return B_DOWN;
	
	if (abs(BUTTON_LEFT - val) <= BUTTON_RANGE)
		return B_LEFT;
	
	if (abs(BUTTON_RIGHT - val) <= BUTTON_RANGE)
		return B_RIGHT;
	
	if (abs(BUTTON_UP - val) <= BUTTON_RANGE)
		return B_UP;
	
	if (abs(BUTTON_PRESSED - val) <= BUTTON_RANGE)
		return B_PRESSED;
	
	if (abs(BUTTON_STATIC - val) <= BUTTON_RANGE)
		return B_STATIC;
	
	else
		return B_ERROR;
}


void oled_print_button(uint8_t row, uint8_t col){
	oled_clear(Pen_Clear);
	oled_button_val_t pos= oled_button_val();
	switch(pos){
		case(B_DOWN):
			oled_printf(row, col, "DOWN");
			break;
		case(B_LEFT):
			oled_printf(row, col, "LEFT");
			break;
		case(B_RIGHT):
			oled_printf(row, col, "RIGHT");
			break;
		case(B_UP):
			oled_printf(row, col, "UP");
			break;
		case(B_PRESSED):
			oled_printf(row, col, "PRESSED");
			break;
		case(B_STATIC):
			oled_printf(row, col, "STATIC");
			break;
		case(B_ERROR):
			oled_printf(row, col, "ERROR");
			break;
	}
	oled_refresh_gram();

}
